using System;
using System.Math;
using System.Threading;

class FSM5  {
  long count=0;
  private long max4(long a1,long a2,long a3,long a4) {
    long m=a1;
    if (a2>m) {
      m=a2;
    }
    if (a3>m) {
      m=a3;
    }
    if (a4>m) {
      m=a4;
    }
    // Console.WriteLine(m);
    count-=1;
    return m;
  }

  public async evA(long a);   
  public async evB(long b);
  public async evC(long c);   
  public async evD(long d);
  public async evE(long e);


  private async unblock();

  public void s() 
    & evA(long a) & evB(long b) & evC(long c) & evD(long d) {
    long m=max4(a,b,c,d);
    if (m<count)
      evE(m+1);
    else
      unblock();
  }
  & evE(long e) & evA(long a) & evB(long b) & evC(long c) {
    long m=max4(a,b,c,e);
    if (m<count)
      evD(m+1);
    else
      unblock();
  }
  & evD(long d) & evE(long e) & evA(long a) & evB(long b) {
    long m=max4(d,e,a,b);
    if (m<count)
      evC(m+1);
    else
      unblock();
  }
  & evC(long c) & evD(long d) & evE(long e) & evA(long a) {
    long m=max4(c,d,e,a);
    if (m<count)
      evB(m+1);
    else
      unblock();
  }
  & evB(long b) & evC(long c) & evD(long d) & evE(long e) {
    long m=max4(b,c,d,e);
    if (m<count)
      evA(m+1);
    else
      unblock();
  }


  private DateTime block_inner() & unblock() {
    //return DateTime.Now.Ticks;
    return DateTime.Now;
  }
  public DateTime block() { // can not be part of chord
    return block_inner();
  } 
  public FSM5(long cnt) {
    count=cnt;
  }
}



public class Program {
  FSM5 fsm;
  long count;
  int sleep=1;
  public Program(long _count) {
    //Console.WriteLine("Constructor");
    this.count=_count;
    fsm=new FSM5(_count);
    //Console.WriteLine("constructor done");
  }
  public static void Main() {
    Console.WriteLine("Grid Bench 5");
    for (int i=0;i<8;i++) {
      GC.Collect();
      Thread.Sleep(1000);
      Program p=new Program(1000*1000*2);
      p.start_measurement();
      Thread.Sleep(3000);
    }
  }
  private void sThread() {
    for (long iter=0;iter<=count;iter++) {
      fsm.s();
    }
  }
  private void aThread() {
    for (long iter=0;iter<=count;iter++) {
      fsm.evA(35);
      Thread.Sleep(sleep);
    } 
  }

  private void bThread() {
    for (long iter=0;iter<=count;iter++) {
      fsm.evB(35);
    } 
  }
  private void cThread() {
    for (long iter=0;iter<=count;iter++) {
      fsm.evC(35);
    } 
  }
  private void dThread() {
    for (long iter=0;iter<=count;iter++) {
      fsm.evD(35);
    } 
  }
  private void eThread() {
    for (long iter=0;iter<=count;iter++) {
      fsm.evE(35);
    } 
  }
  public void start_measurement() {
    Thread t1=new Thread(new ThreadStart(this.aThread));
    Thread t2=new Thread(new ThreadStart(this.bThread));
    Thread t3=new Thread(new ThreadStart(this.cThread));
    Thread t4=new Thread(new ThreadStart(this.dThread));
    Thread t5=new Thread(new ThreadStart(this.eThread));
    Thread ts=new Thread(new ThreadStart(this.sThread));
  
    DateTime before=DateTime.Now; 
    t1.Start();
    t2.Start();
    t3.Start();
    t4.Start();
    t5.Start();
    ts.Start();
    DateTime after=fsm.block(); // wait until  event sequences finish
    double ms=(after.Subtract(before)).TotalMilliseconds;
    
    Console.WriteLine(""+ms+"   normalize 1k "+String.Format("{0:0.00}",(1000*ms/count))+" ,  "+count+" cycles  throughput "+String.Format("{0:0.000}",(1000.0*count)/ms))  ;
  }

}
