using System;
using System.Math;
using System.Threading;
using System.Diagnostics;
using System.Runtime.CompilerServices;

// Empty Benchmark for comparison
// using async methods up and down is very slow, but making them void is too fast
public abstract class AbstractFSM {
  public abstract double methd(int n);
}

class FSM : AbstractFSM {

  override public double methd(int n) {
    return 1/Math.Sin(n*1.001);
  }
 
}

public class Program {
  AbstractFSM fsm;
  long count;
  public Program(long _count) {
    //Console.WriteLine("Constructor");
    this.count=_count;
    fsm=new FSM();
    //Console.WriteLine("constructor done");
  }
  public static void Main() {
    for (int i=0;i<=5;i++) {
      Program p=new Program(500000);
      p.start_measurement();
      Thread.Sleep(4000);
    }
  }

  public void start_measurement() {
    double acc=0;
    long before=DateTime.Now.Ticks;
    int iter=0;
    while (iter<count) {
     acc *= fsm.methd(iter);
     iter+=1;
    }
    long after=DateTime.Now.Ticks;
    double ms=new TimeSpan(after-before).TotalMilliseconds;
    Console.WriteLine(""+ms+"   normalize 1k "+(1000*ms/count)+" "+count+" cycles")   ;
  }

}
