
let fsm count=
    def lev0(n1) & up(n)   = if n1>0 then lev1(n1-1) else unblock()
    or lev1(n2) & up(n)    = if n2>0 then lev2(n2-1) else unblock()
    or lev2(n3) & up(n)    = if n3>0 then lev3(n3-1) else unblock()
    or lev3(n4) & down(n)  = if n4>0 then lev2(n4-1) else unblock() 
    or lev2(n5) & down(n)  = if n5>0 then lev1(n5-1) else unblock() 
    or lev1(n6) & down(n)  = if n6>0 then lev0(n6-1) else unblock() 
    or unblock() & block()    = reply  Unix.gettimeofday() to block   in
    spawn lev0(count) ;
    (up, down,block)
;;


let utils(u,d,iterations)=
  let rec upper_iter(iteration,limit)  =spawn(u(iteration));if iteration<limit then upper_iter(iteration+1,limit) in
  let rec downer_iter(iteration,limit) =spawn(d(iteration));if iteration<limit then downer_iter(iteration+1,limit) in
  def upThread(count) = print_string("U");upper_iter(0,count);0  in
  def downThread(count) = print_string("D");downer_iter(0,count);0  in
  (upThread,downThread) ;;


let experiment(iterations)=
let (u,d,block)=fsm(iterations) in
  let (upThread,downThread) = utils(u,d,iterations) in
    let bfr=Unix.gettimeofday() in 
    spawn(upThread(iterations) & downThread(iterations));
    let time=block () -. bfr in
      print_newline();
      print_string(" total time ");
      print_float(time);
      print_string("  ");
      print_float(1000.0 *. 1000.0 *. time /. float_of_int(iterations));
      print_string(" ms for 1K ,");
      print_int(iterations);
      print_string(" cycles, throughput (/s): ");
      print_float(float_of_int(iterations) /. time);
      print_newline();;

let rec repeated(count,iterations)=experiment(iterations);Gc.compact();Unix.sleep(3);if count>0 then repeated(count-1,iterations);;

repeated(8,500000);;

exit 0;;
