
  (* adding a number would count absorbed unblocks *)
let fsm()=
    def free(n1) & unblock() = free(n1+1) 
    or busy(n2) & unblock()  = free(0) 
    or free(n3) & block()    = busy(n3)  & reply  to block   in
    spawn free(0) ;
    (block, unblock)
;;
  (* fsm is like a constructor *)

let (b,u)=fsm() ;;

  (* b and u and methods b sync method like, u needs to be spawned *)


   (* show and repeat_unblock will be the API they both have type unit->()   *)

let repeat_unblock interval times=
    def w(i)=Unix.sleep(interval);spawn u() & if i>0 then w(i-1) ; 0 in spawn w(times);;
  (* repeated unblocks with a specified interval for a number of times *)

let show name=let a=b() in print_string(name); ignore a ;;
  (* show prints a string when no longer blocked *)


spawn u() ;;

  (* example to use both functions for real now*)
repeat_unblock 6 10 ;  (* 10 times 6 second interval *)
Unix.sleep(1);
show ("done 1") ;;
show ("done 2") ;;
show ("done 3") ;;
show ("done 4") ;;


