
let fsm count=
    def up(n3)    = if n3>=count then spawn (unblock_u()) ; reply to up 
    or  down(n4)  = if n4>=count then spawn (unblock_d()) ; reply to down
    or block() & unblock_u() & unblock_d()   = reply  Unix.gettimeofday() to block   in
    (up, down,block)
;;


let utils(u,d,iterations)=
  let rec upper_iter(iteration,limit)  =u(iteration);if iteration<limit then upper_iter(iteration+1,limit) in
  let rec downer_iter(iteration,limit) =d(iteration);if iteration<limit then downer_iter(iteration+1,limit) in
  def upThread(count) = print_string("U");upper_iter(0,count);0  in
  def downThread(count) = print_string("D");downer_iter(0,count);0  in
  (upThread,downThread) ;;


let experiment(iterations)=
let (u,d,block)=fsm(iterations) in
  let (upThread,downThread) = utils(u,d,iterations) in
    let bfr=Unix.gettimeofday() in 
    spawn(upThread(iterations) & downThread(iterations));
    let time=block () -. bfr in
      print_newline();
      print_string(" total time ");
      print_float(time);
      print_string("  ");
      print_float(1000.0 *. 1000.0 *. time /. float_of_int(iterations));
      print_string(" ms for 1K ,");
      print_int(iterations);
      print_string(" cycles");
      print_newline();;


let rec repeated(count,iterations)=experiment(iterations);if count>0 then repeated(count-1,iterations);;

repeated(5,500000);;

exit 0;;
