let rec max_list = function
| [] -> invalid_arg "empty list"
| [a] -> a
| t :: s -> max t (max_list s);;



let fsm count=
    def unblock() & block(strt)    = reply Unix.gettimeofday() to block
    or ea(n11) & eb(n12) & ec(n13) & s(n1)    =  reply (n1+1) to s &  if count<max_list([n1;n11;n12;n13]) then
                                       ed(n11+n12+n13)
                                       else
                                       unblock()
                                  

    or ed(n21) &  ea(n22) & eb(n23) & s(n2)     =  reply (n2+1) to s &
                                       if count<max_list([n2;n21;n22;n23]) then
                                       ec(n21+n22+n23)
                                       else
                                       unblock()
                                       
     or ec(n31) & ed(n32) &  ea(n33) & s(n3)     =  reply (n3+1) to s &
                                       if count<max_list([n3;n31;n32;n33]) then
                                       eb(n31+n32+n33)
                                       else
                                       unblock()

                                      
     or eb(n41) & ec(n42) & ed(n43) & s(n4)     =  reply (n4+1) to s &
                                       if count<max_list([n4;n41;n42;n43]) then
                                       eb(n41+n42+n43)
                                       else
                                       unblock()				      
     in
    ([ea;eb;ec;ed],s,block)
;;


let asyncSend(events)= 
  let rec trigger = function
  | [] -> ()
  | t :: s -> (spawn(t(35)); trigger(s)) in
    let rec iter(iteration,limit)  = trigger(events);if iteration<=limit then iter(iteration+1,limit) else ()  in
    def async(count) = iter(0,count);0  in
    async ;;


let syncSend(spinner)= 
    let rec iter(iteration,limit)  = spinner(iteration);if iteration<=limit then iter(iteration+1,limit) else ()  in
    def sync(count) = iter(0,count);0  in
    sync ;;

let experiment(iterations)=
  let (events,spinner,block)=fsm(iterations) in
      let syncSender=syncSend(spinner) in
	  let asyncSender=asyncSend(events) in
	      let bfr=Unix.gettimeofday() in 
    spawn (syncSender(iterations) & asyncSender(iterations));
    let time=block () -. bfr in
      print_string(" total time ");
      print_float(time);
      print_string("  ");
      print_float(1000.0 *. 1000.0 *. time /. float_of_int(iterations));
      print_string(" ms for 1K ,");
      print_int(iterations);
      print_string(" cycles, throughput (/s): ");
      print_float(float_of_int(iterations) /. time);
      print_newline();;




let rec repeated(count,iterations)=experiment(iterations);Gc.compact();Unix.sleep(3);if count>0 then repeated(count-1,iterations);;




repeated(8,1000*1000);;

exit 0;;
