let rec max_list = function
| [] -> invalid_arg "empty list"
| [a] -> a
| t :: s -> max t (max_list s);;



let fsm count=
    def unblock() & block(strt)    = reply Unix.gettimeofday() to block
    or ea(n11) & eb(n12) & ec(n13) & ed(n14)  & ee(n15)  & s(n1)    =  reply (n1+1) to s &  if count<max_list([n1;n11;n12;n13;n14;n15]) then
                                       ef(n11+n12+n13+n14+n15)
                                       else
                                       unblock()

    or ef(n21) & ea(n22) & eb(n23) & ec(n24)  & ed(n25)  & s(n2)    =  reply (n2+1) to s &  if count<max_list([n2;n21;n22;n23;n24;n25]) then
                                       ee(n21+n22+n23+n24+n25)
                                       else
                                       unblock()
                                                                

    or ee(n31) & ef(n32) & ea(n33) & eb(n34)  & ec(n35)  & s(n3)    =  reply (n3+1) to s &  if count<max_list([n3;n31;n32;n33;n34;n35]) then
                                       ed(n31+n32+n33+n34+n35)
                                       else
                                       unblock()
                                                     
    or ed(n41) & ee(n42) & ef(n43) & ea(n44)  & eb(n45)  & s(n4)    =  reply (n4+1) to s &  if count<max_list([n4;n41;n42;n43;n44;n45]) then
                                       ec(n41+n42+n43+n44+n45)
                                       else
                                       unblock()
 
     or ec(n51) & ed(n52) & ee(n53) & ef(n54)  & ea(n55)  & s(n5)    =  reply (n5+1) to s &  if count<max_list([n5;n51;n52;n53;n54;n55]) then
                                       eb(n51+n52+n53+n54+n55)
                                       else
                                       unblock()
     or eb(n61) & ec(n62) & ed(n63) & ee(n64)  & ef(n65)  & s(n6)    =  reply (n6+1) to s &  if count<max_list([n6;n61;n62;n63;n64;n65]) then
                                       ea(n61+n62+n63+n64+n65)
                                       else
                                       unblock()
 
    			      			      
     in
    ([ea;eb;ec;ed;ee;ef],s,block)
;;


let asyncSend(events)= 
  let rec trigger = function
  | [] -> ()
  | t :: s -> (spawn(t(35)); trigger(s)) in
    let rec iter(iteration,limit)  = trigger(events);if iteration<=limit then iter(iteration+1,limit) else ()  in
    def async(count) = iter(0,count);0  in
    async ;;


let syncSend(spinner)= 
    let rec iter(iteration,limit)  = spinner(iteration);if iteration<=limit then iter(iteration+1,limit) else ()  in
    def sync(count) = iter(0,count);0  in
    sync ;;

let experiment(iterations)=
  let (events,spinner,block)=fsm(iterations) in
      let syncSender=syncSend(spinner) in
	  let asyncSender=asyncSend(events) in
	      let bfr=Unix.gettimeofday() in 
    spawn (syncSender(iterations) & asyncSender(iterations));
    let time=block () -. bfr in
      print_string(" total time ");
      print_float(time);
      print_string("  ");
      print_float(1000.0 *. 1000.0 *. time /. float_of_int(iterations));
      print_string(" ms for 1K ,");
      print_int(iterations);
      print_string(" cycles, throughput (/s): ");
      print_float(float_of_int(iterations) /. time);
      print_newline();;




let rec repeated(count,iterations)=experiment(iterations);Gc.compact();Unix.sleep(3);if count>0 then repeated(count-1,iterations);;




repeated(8,700*1000);;

exit 0;;
